"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("lodash/merge"),t=require("vue"),a=require("lodash/drop"),l=require("lodash/every"),r=require("lodash/forEach"),s=require("lodash/get"),o=require("lodash/isArray"),n=require("lodash/map"),u=require("lodash/set"),i=require("papaparse"),p=require("lodash/findKey"),c=require("axios");function d(e){return e&&"object"==typeof e&&"default"in e?e:{default:e}}var m=d(e),v=d(a),f=d(l),g=d(r),C=d(s),b=d(o),V=d(n),y=d(u),h=d(i),k=d(p),D=d(c);const S={errors:{fileRequired:"A file is required",invalidMimeType:"Invalid file type"},toggleHeaders:"File has headers",submitBtn:"Submit",fieldColumn:"Field",csvColumn:"Column",requiredField:"*",excludeField:"Exclude field"};var B={props:{modelValue:Array,fields:{type:[Object,Array],required:!0},text:{default:()=>({})}},setup(e,{emit:a}){let l=t.reactive({errors:[],inputName:"csv",file:null,map:{},value:{},fields:(r=e.fields,b.default(r)?V.default(r,(e=>({key:e,label:e,required:!0}))):V.default(r,((e,t)=>({key:t,label:C.default(e,"label",e),required:C.default(e,"required",!0)})))),fileHasHeaders:null,csvSample:null,rawCsv:null,language:m.default({},S,e.text),firstSampleRow:t.computed((()=>b.default(l.csvSample)&&b.default(l.csvSample[0])?l.csvSample[0]:null)),allFieldsAreMapped:t.computed((()=>f.default(l.fields,(function(e){return void 0!==l.map[e.key]||!e.required}))))});var r;return t.provide("VueCsvImportData",l),t.provide("buildMappedCsv",(function(){let e=l.fileHasHeaders?l.rawCsv:v.default(l.rawCsv);l.value=V.default(e,(e=>{let t={};return g.default(l.map,((a,l)=>{y.default(t,l,C.default(e,a))})),t})),a("update:modelValue",l.value)})),{VueCsvImportData:l}}};B.render=function(e,a,l,r,s,o){return t.renderSlot(e.$slots,"default",{errors:r.VueCsvImportData.errors,fields:r.VueCsvImportData.fields,file:r.VueCsvImportData.file})},B.__file="src/components/VueCsvImport.vue";var I={name:"VueCsvFiles",setup:()=>({VueCsvImportData:t.inject("VueCsvImportData")})};I.render=function(e,a,l,r,s,o){return t.renderSlot(e.$slots,"default",{errors:r.VueCsvImportData.errors.value},(()=>[(t.openBlock(!0),t.createBlock(t.Fragment,null,t.renderList(r.VueCsvImportData.errors,(a=>(t.openBlock(),t.createBlock("span",e.$attrs,t.toDisplayString(a),17)))),256))]))},I.__file="src/components/VueCsvErrors.vue";const x={"text/csv":{source:"iana",compressible:!0,extensions:["csv"]},"application/vnd.ms-excel":{source:"iana",compressible:!1,extensions:["xls","xlm","xla","xlc","xlt","xlw"]},"text/plain":{source:"iana",compressible:!0,extensions:["txt","text","conf","def","list","log","in","ini"]}};var M={name:"CsvFile",props:{name:{type:String,default:"csv"},headers:{type:[Boolean,null],default:!0},parseConfig:{type:Object,default:()=>({})},validation:{type:Boolean,default:!0},fileMimeTypes:{type:Array,default:()=>["text/csv","text/x-csv","application/vnd.ms-excel","text/plain"]}},setup(e){const a=t.ref(null),l=t.inject("VueCsvImportData"),r=t.inject("buildMappedCsv"),s=l.language;l.inputName=name,l.fileHasHeaders=null!==e.headers?!!e.headers:null;const o=function(t){if(l.errors=[],t||l.errors.push(s.errors.fileRequired),e.validation){const a=""===t.type?function(e){if(!e||"string"!=typeof e)return!1;let t=e.split(".").pop();return t&&k.default(x,(e=>e.extensions.includes(t)))||!1}(t.name):t.type;return e.fileMimeTypes.includes(a)||l.errors.push(s.errors.invalidMimeType),0===l.errors.length}return!0};return t.watch((()=>l.file),(t=>{t||(l.csvSample.value=null,l.rawCsv.value=null);let a=new FileReader;a.readAsText(l.file,e.parseConfig.encoding||"UTF-8"),a.onload=function(t){l.csvSample=C.default(h.default.parse(t.target.result,m.default({preview:10,skipEmptyLines:!0},e.parseConfig)),"data"),l.rawCsv=C.default(h.default.parse(t.target.result,m.default({skipEmptyLines:!0},e.parseConfig)),"data")},a.onerror=function(e){console.log(e)}}),{deep:!0}),t.watch((()=>l.fileHasHeaders),(()=>{l.allFieldsAreMapped&&r()})),{file:l.file,change:function(){let e=a.value.files?a.value.files[0]:null;o(e)&&(l.file=e)},csvRef:a}}};M.render=function(e,a,l,r,s,o){return t.renderSlot(e.$slots,"default",{file:r.file,change:r.change},(()=>[t.createVNode("input",t.mergeProps({ref:"csvRef",type:"file",onChange:a[1]||(a[1]=(...e)=>r.change&&r.change(...e)),name:l.name},e.$attrs),null,16,["name"])]))},M.__file="src/components/VueCsvInput.vue";var H={name:"CsvMap",props:{noThead:{type:Boolean,default:!1},selectAttributes:{type:Object,default:()=>({})},autoMatch:{type:Boolean,default:!0},autoMatchIgnoreCase:{type:Boolean,default:!0}},setup(e){const a=t.inject("VueCsvImportData"),l=t.inject("buildMappedCsv"),r=a.language;return t.watch((()=>a.map),(function(){a.allFieldsAreMapped&&l()}),{deep:!0}),e.autoMatch&&t.watch((()=>a.csvSample),(function(t){t&&a.fields.forEach((l=>{t[0].forEach(((t,r)=>{(e.autoMatchIgnoreCase?l.label.toLowerCase().trim():l.label.trim())===(e.autoMatchIgnoreCase?t.toLowerCase().trim():t.trim())&&(a.map[l.key]=r)}))}))})),{VueCsvImportData:a,labels:r}}};const w={key:0},q={key:0,value:null};H.render=function(e,a,l,r,s,o){return t.renderSlot(e.$slots,"default",{sample:r.VueCsvImportData.firstSampleRow,map:r.VueCsvImportData.map,fields:r.VueCsvImportData.fields},(()=>[r.VueCsvImportData.firstSampleRow?(t.openBlock(),t.createBlock("table",t.mergeProps({key:0},e.$attrs),[l.noThead?t.createCommentVNode("v-if",!0):(t.openBlock(),t.createBlock("thead",w,[t.createVNode("tr",null,[t.createVNode("th",null,t.toDisplayString(r.labels.fieldColumn),1),t.createVNode("th",null,t.toDisplayString(r.labels.csvColumn),1)])])),t.createVNode("tbody",null,[(t.openBlock(!0),t.createBlock(t.Fragment,null,t.renderList(r.VueCsvImportData.fields,((e,a)=>(t.openBlock(),t.createBlock("tr",{key:a},[t.createVNode("td",null,t.toDisplayString(e.label),1),t.createVNode("td",null,[t.withDirectives(t.createVNode("select",t.mergeProps(l.selectAttributes,{name:`csv_uploader_map_${a}`,"onUpdate:modelValue":t=>r.VueCsvImportData.map[e.key]=t}),[e.required?t.createCommentVNode("v-if",!0):(t.openBlock(),t.createBlock("option",q," ")),(t.openBlock(!0),t.createBlock(t.Fragment,null,t.renderList(r.VueCsvImportData.firstSampleRow,((e,a)=>(t.openBlock(),t.createBlock("option",{key:a,value:a},t.toDisplayString(e),9,["value"])))),128))],16,["name","onUpdate:modelValue"]),[[t.vModelSelect,r.VueCsvImportData.map[e.key]]])])])))),128))])],16)):t.createCommentVNode("v-if",!0)]))},H.__file="src/components/VueCsvMap.vue";var N={name:"CsvTableMap",props:{tableAttributes:{type:Object,default:()=>({})},autoMatch:{type:Boolean,default:!0},autoMatchIgnoreCase:{type:Boolean,default:!0}},setup(e){const a=t.inject("VueCsvImportData"),l=t.inject("buildMappedCsv"),r=a.language,s=t.reactive({}),o=t.computed((()=>a.fields.map((e=>(e.selected=Object.values(s).includes(e.label),e)))));t.watch((()=>s),(function(){a.map={};for(const[e,t]of Object.entries(s))""!==t&&(a.map[t.toLowerCase()]=e);a.allFieldsAreMapped&&l()}),{deep:!0});const n=t.computed((()=>a.fileHasHeaders?a.csvSample:a.csvSample.slice(1))),u=t.computed((()=>a.fileHasHeaders?[...Array(a.firstSampleRow.length).keys()].map((e=>`${r.csvColumn} ${e}`)):a.firstSampleRow));return e.autoMatch&&t.watch((()=>a.csvSample),(function(t){t&&a.fields.forEach((a=>{t[0].forEach(((t,l)=>{(e.autoMatchIgnoreCase?a.label.toLowerCase().trim():a.label.trim())===(e.autoMatchIgnoreCase?t.toLowerCase().trim():t.trim())&&(s[l]=a.label)}))}))})),{availableFields:o,csvMap:s,csvSample:n,headers:u,VueCsvImportData:a,labels:r}}};const F={value:""};N.render=function(e,a,l,r,s,o){return t.renderSlot(e.$slots,"default",{sample:r.VueCsvImportData.firstSampleRow,map:r.VueCsvImportData.map,fields:r.VueCsvImportData.fields},(()=>[r.VueCsvImportData.firstSampleRow?(t.openBlock(),t.createBlock("table",t.mergeProps({key:0},l.tableAttributes),[t.createVNode("thead",null,[t.createVNode("tr",null,[(t.openBlock(!0),t.createBlock(t.Fragment,null,t.renderList(r.headers,((e,a)=>(t.openBlock(),t.createBlock("td",{key:e},[t.createTextVNode(t.toDisplayString(e)+" ",1),t.withDirectives(t.createVNode("select",{"onUpdate:modelValue":e=>r.csvMap[a]=e,name:`csv_uploader_map_${a}`,required:""},[t.createVNode("option",F,t.toDisplayString(r.labels.excludeField),1),(t.openBlock(!0),t.createBlock(t.Fragment,null,t.renderList(r.availableFields,(e=>(t.openBlock(),t.createBlock("option",{value:e.label,key:e.key,disabled:e.selected},t.toDisplayString(e.label)+t.toDisplayString(e.required?r.labels.requiredField:""),9,["value","disabled"])))),128)),r.VueCsvImportData.fields.map((e=>e.label)).includes(e)?t.createCommentVNode("v-if",!0):(t.openBlock(),t.createBlock("option",{value:e,key:e},t.toDisplayString(e),9,["value"]))],8,["onUpdate:modelValue","name"]),[[t.vModelSelect,r.csvMap[a]]])])))),128))])]),t.createVNode("tbody",null,[(t.openBlock(!0),t.createBlock(t.Fragment,null,t.renderList(r.csvSample,(e=>(t.openBlock(),t.createBlock("tr",null,[(t.openBlock(!0),t.createBlock(t.Fragment,null,t.renderList(e,(e=>(t.openBlock(),t.createBlock("td",null,t.toDisplayString(e),1)))),256))])))),256))])],16)):t.createCommentVNode("v-if",!0)]))},N.__file="src/components/VueCsvTableMap.vue";var _={name:"VueCsvImportSubmit",props:{url:{type:String,required:!0},config:{type:Object,required:!1,default:{}}},setup(e){const a=t.inject("VueCsvImportData"),l=t.inject("buildMappedCsv"),r=a.language;return{submit:function(){l(),D.default.post(e.url,{[a.inputName]:a.value},e.config).then((e=>{emit("send-success",e)})).catch((e=>{emit("send-error",e)})).finally((e=>{emit("send-complete",e)}))},VueCsvImportData:a,labels:r}}};_.render=function(e,a,l,r,s,o){return t.renderSlot(e.$slots,"submit",{submit:r.submit,mappedCsv:r.VueCsvImportData.value},(()=>[t.createVNode("button",t.mergeProps({type:"submit"},e.$attrs,{onClick:a[1]||(a[1]=t.withModifiers(((...e)=>r.submit&&r.submit(...e)),["prevent"]))}),t.toDisplayString(r.labels.submitBtn),17)]))},_.__file="src/components/VueCsvSubmit.vue";var j={name:"ToggleHasHeaders",props:{labelAttributes:{},checkboxAttributes:{}},setup(){const e=t.inject("VueCsvImportData"),a=e.language;return{VueCsvImportData:e,toggleHasHeaders:function(){e.fileHasHeaders=!e.fileHasHeaders},labels:a}}};j.render=function(e,a,l,r,s,o){return t.renderSlot(e.$slots,"default",{hasHeaders:r.VueCsvImportData.fileHasHeaders,toggle:r.toggleHasHeaders},(()=>[t.createVNode("label",l.labelAttributes,[t.createVNode("input",t.mergeProps({type:"checkbox"},l.checkboxAttributes,{value:r.VueCsvImportData.fileHasHeaders,onChange:a[1]||(a[1]=(...e)=>r.toggleHasHeaders&&r.toggleHasHeaders(...e))}),null,16,["value"]),t.createTextVNode(" "+t.toDisplayString(r.labels.toggleHeaders),1)],16)]))},j.__file="src/components/VueCsvToggleHeaders.vue";const A={install(e,t){t=m.default({components:{"vue-csv-import":"vue-csv-import","vue-csv-errors":"vue-csv-errors","vue-csv-input":"vue-csv-input","vue-csv-map":"vue-csv-map","vue-csv-table-map":"vue-csv-table-map","vue-csv-submit":"vue-csv-submit","vue-csv-toggle-headers":"vue-csv-toggle-headers"}},t),e.component(t.components["vue-csv-import"],B),e.component(t.components["vue-csv-errors"],I),e.component(t.components["vue-csv-input"],M),e.component(t.components["vue-csv-map"],H),e.component(t.components["vue-csv-table-map"],N),e.component(t.components["vue-csv-submit"],_),e.component(t.components["vue-csv-toggle-headers"],j)}};exports.VueCsvErrors=I,exports.VueCsvImport=B,exports.VueCsvImportPlugin=A,exports.VueCsvInput=M,exports.VueCsvMap=H,exports.VueCsvSubmit=_,exports.VueCsvTableMap=N,exports.VueCsvToggleHeaders=j;
